%define _unpackaged_files_terminate_build 0%{nil}
%define __os_install_post /usr/lib/rpm/brp-compress %{nil}
%define current_version 7.0.0

%define vzpkgenv_path	vz/pkgenv

%define environment	vzpkgenvdeb

%define __find_provides %{nil}
%define __os_install_post %{nil}

%define technologies	"x86_64 nptl"
%define vzpkgenv_name	vzpkgenvdebx64
%define vzpkgenv_name_32	vzpkgenvdeb
%define vzpkgenv_name_ma	vzpkgenvdeb_max64
%define vzpkgenv_name_ma_32	vzpkgenvdeb_ma
%define pkgman_name	dpkgx64
%define pkgman_name_32	dpkg
%define pkgman_name_ma	dpkg_max64
%define pkgman_name_ma_32	dpkg_ma
%define makefile	packages.x86_64

%define pkgman_path	%{vzpkgenv_path}/%{pkgman_name}


Summary: Chroot environment for dpkg
Name: vzpkgenvdebx64
Version: %{current_version}
Release: 20%{?dist}
Group: System Environment/Base
License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-root
AutoReq: 0
AutoProv: 0
ExclusiveArch: x86_64
Obsoletes: %{vzpkgenv_name_ma} %{vzpkgenv_name_32} %{vzpkgenv_name_ma_32}
Provides: %{vzpkgenv_name_ma} = %{version}-%{release}
Provides: %{vzpkgenv_name_32} = %{version}-%{release}
Provides: %{vzpkgenv_name_ma_32} = %{version}-%{release}
Requires: /bin/ln
BuildRequires: xz

# Patched packages
Source100: apt_1.0.9.7ubuntu4.1.vz_amd64.deb
Source101: apt-transport-https_1.0.9.7ubuntu4.1.vz_amd64.deb
Source102: apt-utils_1.0.9.7ubuntu4.1.vz_amd64.deb
Source103: dpkg_1.19.0.5ubuntu2.1_amd64.deb
Source104: dselect_1.19.0.5ubuntu2.1_amd64.deb
Source105: libapt-pkg4.12_1.0.9.7ubuntu4.1.vz_amd64.deb
Source106: tar_1.29b-2_amd64.deb

# Original packages
Source108: dash_0.5.8-2.1ubuntu2_amd64.deb
Source109: libbz2-1.0_1.0.6-7_amd64.deb
Source110: libc6_2.23-0ubuntu11.2_amd64.deb
Source111: libgcc1_1%253a5.1~rc1-0ubuntu1_amd64.deb
Source112: liblzma5_5.2.2-1.3_amd64.deb
Source113: libselinux1_2.3-2_amd64.deb
Source114: libstdc++6_5.3.1-14ubuntu2_amd64.deb
Source115: xz-utils_5.1.1alpha+20120614-2ubuntu2_amd64.deb
Source116: zlib1g_1%253a1.2.8.dfsg-2ubuntu1_amd64.deb
Source117: libpcre3_2%253a8.35-3.3ubuntu1_amd64.deb
Source118: libacl1_2.2.52-2_amd64.deb
Source119: libattr1_1%253a2.4.47-2_amd64.deb
Source120: libzstd1_1.3.3+dfsg-2ubuntu1_amd64.deb

Source121: libasn1-8-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source122: libcurl3-gnutls_7.47.0-1ubuntu2.15_amd64.deb
Source123: libffi6_3.2.1-4_amd64.deb
Source124: libgmp10_2%253a6.1.0%2Bdfsg-2_amd64.deb
Source125: libgnutls30_3.4.10-4ubuntu1.8_amd64.deb
Source126: libgssapi-krb5-2_1.13.2+dfsg-5ubuntu2.1_amd64.deb
Source127: libgssapi3-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source128: libhcrypto4-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source129: libheimbase1-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source130: libheimntlm0-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source131: libhogweed4_3.2-1ubuntu0.16.04.1_amd64.deb
Source132: libhx509-5-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source133: libidn11_1.32-3ubuntu1.2_amd64.deb
Source134: libk5crypto3_1.13.2+dfsg-5ubuntu2.1_amd64.deb
Source135: libkeyutils1_1.5.9-8ubuntu1_amd64.deb
Source136: libkrb5-26-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source137: libkrb5-3_1.13.2+dfsg-5ubuntu2.1_amd64.deb
Source138: libkrb5support0_1.13.2+dfsg-5ubuntu2.1_amd64.deb
Source139: libldap-2.4-2_2.4.42+dfsg-2ubuntu3.9_amd64.deb
Source140: libnettle6_3.2-1ubuntu0.16.04.1_amd64.deb
Source141: libp11-kit0_0.23.2-5~ubuntu16.04.1_amd64.deb
Source142: libroken18-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source143: librtmp1_2.4+20151223.gitfa8646d-1ubuntu0.1_amd64.deb
Source144: libsasl2-2_2.1.26.dfsg1-14ubuntu0.2_amd64.deb
Source145: libsasl2-modules-db_2.1.26.dfsg1-14ubuntu0.2_amd64.deb
Source146: libsasl2-modules_2.1.26.dfsg1-14ubuntu0.2_amd64.deb
Source147: libsqlite3-0_3.11.0-1ubuntu1.5_amd64.deb
Source148: libssl1.0.0_1.0.2g-1ubuntu4.16_amd64.deb
Source149: libtasn1-6_4.7-3ubuntu0.16.04.3_amd64.deb
Source150: libwind0-heimdal_1.7~git20150920+dfsg-4ubuntu1.16.04.1_amd64.deb
Source151: libcomerr2_1.42.13-1ubuntu1.2_amd64.deb


%description
Chroot environment for execution Virtuozzo version of apt-get package

%prep
rm -rf $RPM_BUILD_DIR/%{environment}

%setup -q -Tc -n %{name}

%build

%define debug_package %{nil}

for i in files.lst files.2lst; do
    rm -f $i || /bin/true
    touch $i
done

function parse_find() {
    while read rattr fname; do
	echo $fname >> files.lst
	if [ "${fname%*.pyc}" != "${fname}" ]; then
	    echo %ghost ${fname/.\///%{pkgman_path}/} >> files.2lst
	else
	    echo $rattr ${fname/.\///%{pkgman_path}/} >> files.2lst
	fi
    done
}

packages="%{sources}"
echo $packages

for i in $packages; do
    echo "Unpacking $i"
    ar x $i
    [ $? -ne 0 ] && abort "Can't unpack package $i using ar"
    if [ -f data.tar.xz ]; then
        xzcat data.tar.xz | tar x
    else
        tar xzf data.tar.gz
    fi
    rm -f data.tar.*
    [ $? -ne 0 ] && abort "Can't unpack package $i using tar"
done

echo "include /etc/ld.so.conf.d/*.conf" > etc/ld.so.conf
ldconfig -r .


find ./bin -name sh -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./bin -name dash -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./bin -name tar -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./etc/dpkg -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name apt\* -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name dpkg\* -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/bin -name xz -printf '%%%attr(%m,root,root) %p\n' | parse_find
find ./usr/lib/apt -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so  -printf '%%%attr(%m,root,root) %p\n' | parse_find
find . -name \*.so.*  -printf '%%%attr(%m,root,root) %p\n' | parse_find


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/%{pkgman_path}

tar --files-from=files.lst -cf - | tar --directory %buildroot/%{pkgman_path} -xf -

%ifarch x86_64
for i in usr/lib; do
	ln -s `basename $i` "%{buildroot}/%{pkgman_path}/"$i"64"
	echo "%attr(644,root,root) "/%{pkgman_path}/$i"64" >> files.2lst
done
%endif

echo "%technologies" > %{buildroot}/%{pkgman_path}/technologies
echo "%attr(644,root,root) /%{pkgman_path}/technologies" >> files.2lst

mkdir -p %{buildroot}/%{pkgman_path}/etc/apt/apt.conf.d

for i in `find %{buildroot} -type d | sed "s,^%{buildroot},,g"`; do
	if [ $i != "/vz" ] && [ $i != "/vz/pkgenv" ]; then
		echo "%attr(0755, root, root) %dir $i" >> files.2lst
	fi
done

ln -s %{pkgman_name} %{buildroot}/%{vzpkgenv_path}/%{pkgman_name_ma} > /dev/null 2>&1
echo "%ghost %attr(0755, root, root) /%{vzpkgenv_path}/%{pkgman_name_ma}" >> files.2lst

%clean
rm -rf $RPM_BUILD_DIR/%{environment}

%postun
if [ $1 -eq 0 ]; then
	rm -rf /%{pkgman_path} >/dev/null 2>&1
fi

%pre
for dir in /%{vzpkgenv_path}/%{pkgman_name_ma} /%{vzpkgenv_path}/%{pkgman_name}; do
	if [ -d $dir ]; then
		rm -rf $dir > /dev/null 2>&1
	fi
done

%post
if [ ! -d /%{vzpkgenv_path}/%{pkgman_name_ma} -o ! -s /%{vzpkgenv_path}/%{pkgman_name_ma} ]; then
	ln -s %{pkgman_name} /%{vzpkgenv_path}/%{pkgman_name_ma} > /dev/null 2>&1
fi
if [ ! -d /%{vzpkgenv_path}/%{pkgman_name_ma_32} -o ! -s /%{vzpkgenv_path}/%{pkgman_name_ma_32} ]; then
	ln -s %{pkgman_name} /%{vzpkgenv_path}/%{pkgman_name_ma_32} > /dev/null 2>&1
fi
if [ ! -d /%{vzpkgenv_path}/%{pkgman_name_32} -o ! -s /%{vzpkgenv_path}/%{pkgman_name_32} ]; then
	ln -s %{pkgman_name} /%{vzpkgenv_path}/%{pkgman_name_32} > /dev/null 2>&1
fi

%triggerpostun -- %{vzpkgenv_name_ma} <= 4.6.0-3
ln -s %{pkgman_name} /%{vzpkgenv_path}/%{pkgman_name_ma} > /dev/null 2>&1

%files -f files.2lst

%changelog
* Wed Oct 14 2020 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-20
- upgrade glibc package to prevent issue with libs detection
- resolve #PSBM-121267

* Tue Jul 14 2020 Alexander Stefanov <astefanov@virtuozzo.com> 7.0.0-19
- add libcurl-gnutls.so.4 and friends to the chroot
- resolve #OVZ-7134
- verify gpg signs over debs, see #PSBM-104249

* Tue Aug  9 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.0-15
- Fixed non-digital user/group tarball unpack on install stage

* Wed Jun 08 2016 Konstantin Volkov <wolf@virtuozzo.com> 7.0.0-14
 - Technical rebuild, see #PSBM-47948

* Thu May 05 2016 Denis Silakov <dsilakov@virtuozzo.com> 7.0.0-13
- Rebuilt with apt with patches from Vz6 for consistency

* Tue Jun 30 2015 Konstantin Volkov <wolf@odin.com> 7.0.0-11
- Call tar with explicit path, see #PSBM-34585

* Fri Jun 26 2015 Konstantin Volkov <wolf@odin.com> 7.0.0-10
- Fixed InRelease ubuntu's file processing, see #PSBM-34575

* Fri Jun 26 2015 Konstantin Volkov <wolf@odin.com> 7.0.0-9
- Fixed ContainerID length

* Fri Jun 26 2015 Konstantin Volkov <wolf@odin.com> 7.0.0-8
- Added string VEID support
- Removed VZFS-related code
- Rebased to Ubuntu 15.04
- Added obsoletes for 32-bit vzpkgenvdeb's

* Sat Feb 16 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.0-3
- Move to PCS7

